import unittest

from sybil_engine.config.app_config import set_network
from sybil_engine.data.networks import get_chain_instance
from sybil_engine.data.tokens import get_tokens_for_chain
from sybil_engine.utils.web3_utils import init_web3

from web3_wizzard_lib.core.contract.horizondex_quoter import HorizonDexQuoter
from tests.core.modules import init_set_test_config


class TestHorizonDexQuoter(unittest.TestCase):

    def test_horizondex_quoter(self):
        # "ETH": "0xEeeeeEeeeEeEeeEeEeEeeEEEeeeeEeeeeeeeEEeE",
        # "WETH": "0x4200000000000000000000000000000000000006",
        # return self.contract.functions.quoteExactInputSingle(
        #     (
        #     from_token, to_token, amount, 3000, 0)
        # ).call()[0]
        init_set_test_config()
        set_network('MAIN')
        chain = 'LINEA'
        chain_instance = get_chain_instance(chain)
        web3 = init_web3(chain_instance, None)

        quoter_contract_address = '0x07AceD5690e09935b1c0e6E88B772d9440F64718'

        horizondex = HorizonDexQuoter(quoter_contract_address, web3)

        #from_token_address = get_tokens_for_chain(chain)['WETH']
        from_token_address = get_tokens_for_chain(chain)['WETH']
        to_token_address = get_tokens_for_chain(chain)['USDC']

        price = horizondex.quote_exact_input_single( 1000000000, from_token_address, to_token_address)

        print(price)
