import unittest

from sybil_engine.config.app_config import set_network
from sybil_engine.data.networks import get_chain_instance
from sybil_engine.data.tokens import get_tokens_for_chain
from sybil_engine.utils.file_loader import load_abi
from sybil_engine.utils.web3_utils import init_web3
from web3 import Web3

from tests.core.modules import init_set_test_config

abi = load_abi('resources/abi/uniswap_abi.json')


class TestUniswapQuoter(unittest.TestCase):

    def test_uniswap_quoter(self):
        init_set_test_config()
        set_network('MAIN')
        chain = 'ARBITRUM'
        chain_instance = get_chain_instance(chain)
        web3 = init_web3(chain_instance, None)

        quoter_contract_address = '0xb27308f9F90D607463bb33eA1BeBb41C27CE5AB6'

        from_token_address = get_tokens_for_chain(chain)['WETH']
        to_token_address = get_tokens_for_chain(chain)['USDC']

        web3.eth.contract(quoter_contract_address, abi=abi).functions.quoteExactInputSingle(
            from_token_address,
            to_token_address,
            500,
            Web3.to_wei(1, 'ether'),
            0
        ).call()
