import unittest

from sybil_engine.config.app_config import set_network
from sybil_engine.data.networks import get_chain_instance
from sybil_engine.utils.web3_utils import init_web3

from web3_wizzard_lib.core.contract.velocore_lens import VelocoreLensContract
from tests.core.modules import init_set_test_config


class TestVelocoreLens(unittest.TestCase):

    def test_velocore_pool_get_pool_balance(self):
        # "ETH": "0xEeeeeEeeeEeEeeEeEeEeeEEEeeeeEeeeeeeeEEeE",
        # "WETH": "0x4200000000000000000000000000000000000006",
        # return self.contract.functions.quoteExactInputSingle(
        #     (
        #     from_token, to_token, amount, 3000, 0)
        # ).call()[0]
        init_set_test_config()
        set_network('MAIN')
        chain = 'LINEA'
        chain_instance = get_chain_instance(chain)
        web3 = init_web3(chain_instance, None)

        velocore_lens_contract_address = '0xaA18cDb16a4DD88a59f4c2f45b5c91d009549e06'

        velocore = VelocoreLensContract(velocore_lens_contract_address, web3)

        pool_balance = velocore.getPoolBalance()

        print(pool_balance)

    def test_velocore_pool_user_balances(self):
        # "ETH": "0xEeeeeEeeeEeEeeEeEeEeeEEEeeeeEeeeeeeeEEeE",
        # "WETH": "0x4200000000000000000000000000000000000006",
        # return self.contract.functions.quoteExactInputSingle(
        #     (
        #     from_token, to_token, amount, 3000, 0)
        # ).call()[0]
        init_set_test_config()
        set_network('MAIN')
        chain = 'LINEA'
        chain_instance = get_chain_instance(chain)
        web3 = init_web3(chain_instance, None)

        velocore_lens_contract_address = '0xaA18cDb16a4DD88a59f4c2f45b5c91d009549e06'

        velocore = VelocoreLensContract(velocore_lens_contract_address, web3)

        pool_balance = velocore.userBalances()

        print(pool_balance)

    def test_query(self):
        init_set_test_config()
        set_network('MAIN')
        chain = 'LINEA'
        chain_instance = get_chain_instance(chain)
        web3 = init_web3(chain_instance, None)

        velocore_lens_contract_address = '0xaA18cDb16a4DD88a59f4c2f45b5c91d009549e06'

        velocore = VelocoreLensContract(velocore_lens_contract_address, web3)

        gauge_gauge = velocore.query_gauge()
        print(gauge_gauge)
