import unittest

from sybil_engine.config.app_config import set_network
from sybil_engine.data.networks import get_chain_instance
from sybil_engine.utils.web3_utils import init_web3

from web3_wizzard_lib.core.contract.velocore_lens import VelocoreLensContract
from web3_wizzard_lib.core.contract.velocore_pool import VelocorePoolContract
from tests.core.modules import init_set_test_config


class TestVelocoreVault(unittest.TestCase):

    def test_velocore_vault_all_pairs(self):
        init_set_test_config()
        set_network('MAIN')
        chain = 'LINEA'
        chain_instance = get_chain_instance(chain)
        web3 = init_web3(chain_instance, None)

        velocore_lens_contract_address = '0x1d0188c4B276A09366D05d6Be06aF61a73bC7535'

        velocore = VelocorePoolContract(velocore_lens_contract_address, web3)

        pool_balance = velocore.allPairs()

        print(pool_balance)

    def test_velocore_vault_facets(self):
        init_set_test_config()
        set_network('MAIN')
        chain = 'LINEA'
        chain_instance = get_chain_instance(chain)
        web3 = init_web3(chain_instance, None)

        velocore_lens_contract_address = '0x1d0188c4B276A09366D05d6Be06aF61a73bC7535'

        velocore = VelocorePoolContract(velocore_lens_contract_address, web3)

        facets = velocore.facets()

        for facet in facets:
            print(facet)

    def test_query(self):
        init_set_test_config()
        set_network('MAIN')
        chain = 'LINEA'
        chain_instance = get_chain_instance(chain)
        web3 = init_web3(chain_instance, None)

        velocore_lens_contract_address = '0x1d0188c4B276A09366D05d6Be06aF61a73bC7535'

        velocore = VelocoreLensContract(velocore_lens_contract_address, web3)

        gauge_gauge = velocore.query_gauge()
        print(gauge_gauge)