import unittest

from loguru import logger
from sybil_engine.data.networks import get_chain_instance
from sybil_engine.domain.balance.balance import NativeBalance
from sybil_engine.domain.balance.balance_utils import from_eth_to_wei
from sybil_engine.domain.balance.tokens import Erc20Token
from sybil_engine.utils.web3_utils import init_web3

from web3_wizzard_lib.core.modules import LineaSwap
from tests.core.modules import test_account, init_set_test_config


class TestLineaSwap(unittest.TestCase):
    init_set_test_config()

    def test_lineaswapShouldSwap(self, chain='LINEA'):
        logger.info("Test lineaswap")

        chain_instance = get_chain_instance(chain)
        web3 = init_web3(chain_instance, None)

        native_balance = NativeBalance(from_eth_to_wei(1), 'BASE', 'ETH')

        lineaswap = LineaSwap(chain_instance, web3)
        lineaswap.swap(native_balance, 'ETH', 'LIN', 0.98, test_account)
        amount_to_swap = Erc20Token(chain_instance['chain'], 'LIN', web3).balance(test_account)
        lineaswap.swap(amount_to_swap, 'LIN', 'ETH', 0.98, test_account)
