import unittest

from loguru import logger

from web3_wizzard_lib.core.modules import BungeeRefuel
from tests.core.modules.__init__ import local_evm_test_account, zksync_min_native_balance, init_set_test_config

bungee_test_params = {
    'from_chain': 'ZKSYNC',
    'to_chain': 'BASE',
    'refuel_amount_interval': 'max'
}


class TestBungeeModule(unittest.TestCase):
    init_set_test_config()

    def test_shouldRefuelZksyncToBase(self):
        logger.info("Test module [BUNGEE, 11]")

        try:
            bungee = BungeeRefuel(zksync_min_native_balance, local_evm_test_account)

            bungee.execute(*bungee.parse_params(bungee_test_params), local_evm_test_account)
        except Exception as e:
            self.fail(f"Some function raised an exception: {e}")

