import unittest

from loguru import logger

from web3_wizzard_lib.core.modules.nft.era_domain import EraDomain
from web3_wizzard_lib.core.modules.nft.zks_domain import ZksDomain
from tests.core.modules.__init__ import init_set_test_config, \
    local_evm_test_account


class NftTest(unittest.TestCase):
    init_set_test_config()

    def test_shouldTestEraDomain(self):
        logger.info("Test module [ERA_DOMAIN, 8]")

        try:
            era_domain = EraDomain()

            era_domain.execute(local_evm_test_account)
        except Exception as e:
            self.fail(f"Some function raised an exception: {e}")

    def test_shouldTestZKSDomain(self):
        logger.info("Test module [ZKSDomain, 9]")

        try:
            zks_domain = ZksDomain()

            zks_domain.execute(local_evm_test_account)
        except Exception as e:
            self.fail(f"Some function raised an exception: {e}")
