import unittest

from loguru import logger
from sybil_engine.config.app_config import set_network
from sybil_engine.domain.account_storage import AccountStorage

from web3_wizzard_lib.core.modules import NFTMinter
from tests.core.modules.__init__ import zksync_test_account, zksync_min_native_balance, init_set_test_config

nft_minter_test_config = {
    'nft_amount_interval': {'from': 7, 'to': 7},
    'nft_modules': ["TAVAERA", "ZKS_DOMAIN", "ERA_DOMAIN", "EMPTY_NFT", "OMNI_SEA", "MERKLY_MINTER", "KREATOR_LAND"],
    'sleep_interval': {'from': 0, 'to': 0}
}


class TestRandomNFTModule(unittest.TestCase):
    init_set_test_config()

    def test_shouldMintRandomNFT(self):
        logger.info("Test module [NFT_MINTER, 15]")

        set_network('LOCAL')

        try:
            nft_minter = NFTMinter(zksync_min_native_balance, AccountStorage(), range(4))

            nft_minter.execute(*nft_minter.parse_params(nft_minter_test_config), zksync_test_account)
        except Exception as e:
            self.fail(f"Some function raised an exception: {e}")
