import unittest

from loguru import logger

from web3_wizzard_lib.core.modules.orbiter import OrbiterModule
from tests.core.modules.__init__ import zksync_min_native_balance, init_set_test_config, \
    local_evm_test_account

orbiter_params = {
    'bridge_amount_interval': {'from': 0.1, 'to': 1},
    'from_chain': 'ZKSYNC',
    'to_chain': 'ARBITRUM',
}


class TestOrbiterModule(unittest.TestCase):
    init_set_test_config()

    def test_shouldBridge(self):
        logger.info("Test module [ORBITER, 7]")

        try:
            orbiter = OrbiterModule(zksync_min_native_balance, local_evm_test_account)

            orbiter.execute(*orbiter.parse_params(orbiter_params), local_evm_test_account)
        except Exception as e:
            self.fail(f"Some function raised an exception: {e}")

