import unittest

from loguru import logger

from web3_wizzard_lib.core.modules import SellAll
from tests.core.modules.__init__ import zksync_test_account, zksync_min_native_balance, init_set_test_config


class TestSetAllModule(unittest.TestCase):

    def test_shouldSellAllzkSync(self, chain='ZKSYNC', account=zksync_test_account):
        sell_all_test_config = {
            'chain': chain,
            'receive_token': 'ETH',  # [USDC, ETH]
            'sleep_interval': {'from': 0, 'to': 0}  # Interval between selling different tokens of 1 account
        }

        logger.info("Test module [SELL_ALL, 2]")

        init_set_test_config()

        try:
            sell_all = SellAll(zksync_min_native_balance, account)

            sell_all.execute(*sell_all.parse_params(sell_all_test_config), account)
        except Exception as e:
            self.fail(f"Some function raised an exception: {e}")
