import unittest

from loguru import logger

from web3_wizzard_lib.core.modules import SendToCex
from tests.core.modules.__init__ import zksync_min_native_balance, init_set_test_config, \
    local_evm_test_account

send_to_cex_test_config = {
    'chain': 'ZKSYNC',
    'amount': {'from': 1, 'to': 1},
    'token': 'NATIVE'
}


class TestSendToCexModule(unittest.TestCase):
    init_set_test_config()

    def test_shouldSendToCex(self):
        logger.info("Test module [SEND_TO_CEX, 6]")

        try:
            send_to_cex = SendToCex(zksync_min_native_balance, local_evm_test_account)

            send_to_cex.execute(*send_to_cex.parse_params(send_to_cex_test_config), local_evm_test_account)
        except Exception as e:
            self.fail(f"Some function raised an exception: {e}")
