import unittest

from loguru import logger
from sybil_engine.domain.account_storage import AccountStorage

from web3_wizzard_lib.core.modules.stargate.auto_bridge import StargateAutoBridge
from tests.core.modules.__init__ import init_set_test_config, \
    test_account, test_min_native_balance

stargate_auto_bridge_test_config = {
    'bridge_amount_interval': {'from': 1, 'to': 1},
    'bridge_token': 'ETH',
    'end_network': '',  # name of network where all tokens will be collected
    'retry_interval': {'from': 0, 'to': 0},
    'sleep_interval': {'from': 0, 'to': 0},
    'only_end_network_bridge': False,  # if True, then only bridge will be to END NETWORK
    'original_chain_sequence': ['ARBITRUM', 'LINEA', 'BASE']
}


class TestStargateAutoBridge(unittest.TestCase):
    init_set_test_config()

    def test_shouldMakeAutoBridge(self, account=test_account):
        logger.info("Test module [STARGATE_AUTO_BRIDGE, 13]")

        try:
            stargate_auto_bridge = StargateAutoBridge(test_min_native_balance, AccountStorage())

            stargate_auto_bridge.execute(*stargate_auto_bridge.parse_params(stargate_auto_bridge_test_config), account)
        except Exception as e:
            self.fail(f"Some function raised an exception: {e}")
