import unittest

from loguru import logger

from web3_wizzard_lib.core.modules.stargate.classic_bridge import StargateBridgeModule
from tests.core.modules.__init__ import init_set_test_config, test_min_native_balance, \
    local_evm_test_account

stargate_classic_test_config = {
    'from_chain': 'LINEA',
    'to_chain': 'BASE',
    'bridge_amount_interval': {'from': 1, 'to': 1},
    'bridge_token': 'ETH',
    'retry_interval': {'from': 60 * 25, 'to': 60 * 40}
}


class TestStargateBridgeModule(unittest.TestCase):
    def test_bridgeStargate(self, account=local_evm_test_account):
        logger.info("Test module [STARGATE_BRIDGE, 12]")

        init_set_test_config()

        stargate_bridge = StargateBridgeModule(test_min_native_balance, account)
        stargate_bridge.execute(*stargate_bridge.parse_params(stargate_classic_test_config), account)
