from tests.core.test_config import warmup_allowed_dex

TEST_module_0_config = {
    'scenario_name': 'TEST_module_0_config',
    'scenario': [
        {
            'module': 'WARMUP',
            'params': {
                'chain': 'ZKSYNC',
                'swap_amount_interval': {'from': 1, 'to': 1},
                'token': 'ETH',
                'amount_of_warmups': {'from': 5, 'to': 6},
                'allowed_dex': warmup_allowed_dex,
                'warmup_pairs': [],
                'sell_tokens': True,
                'pair_sleep_interval': {'from': 0, 'to': 0}
            }
        },
        {
            'module': 'NFT_MINTER',
            'params': {
                'nft_amount_interval': {'from': 2, 'to': 5},
                'nft_modules': ["ZKS_DOMAIN", "ERA_DOMAIN", "OMNI_SEA", "MERKLY_MINTER", "L2_TELEGRAPH_MINTER"],
                'sleep_interval': {'from': 0, 'to': 0}
            }
        },
        {
            'module': 'LENDING',
            'params': {
                'amount': {'from': 0.001, 'to': 0.001},
                # 'amount': 'all_balance',
                'action': 'DEPOSIT+WITHDRAW',  # ['DEPOSIT', WITHDRAW', DEPOSIT+WITHDRAW, WITHDRAW_ALL]
                'lending_apps': ['ERALEND', 'REACTOR_FUSION', 'BASILISK'],  # ['ERALEND', 'REACTOR_FUSION', 'BASILISK'],
                'withdraw_sleep_interval': {'from': 0, 'to': 0},
                'repeats': {'from': 4, 'to': 4}  # Количество повторов
                # Интервал между депозитом и выводом, используется только при 'action' DEPOSIT+WITHDRAW
            }
        },
        {
            'module': 'DMAIL',
            'params': {
                'chain': 'ZKSYNC',
                'email_amount': {'from': 3, 'to': 6}
            }
        },
        {
            'module': 'SELL_ALL',
            'params': {
                'chain': 'ZKSYNC',
                'receive_token': 'ETH',  # [USDC, ETH]
                'sleep_interval': {'from': 0, 'to': 0}  # Interval between selling different tokens of 1 account
            }
        },
        {
            'module': 'WRAPPING',
            'params': {
                'chain': 'ZKSYNC',
                'amount_interval': 'all_balance',
                'action': 'UNWRAP'  # [WRAP, UNWRAP]
            }
        },
        {
            'module': 'SEND_TO_CEX',
            'params': {
                'chain': 'ZKSYNC',
                'amount': {'from': 1, 'to': 1}
            }
        },
        {
            'module': 'WARMUP',
            'params': {
                'chain': 'ZKSYNC',
                'swap_amount_interval': {'from': 1, 'to': 1},
                'token': 'ETH',
                'amount_of_warmups': {'from': 5, 'to': 6},
                'allowed_dex': warmup_allowed_dex,
                'warmup_pairs': [],
                'sell_tokens': True,
                'pair_sleep_interval': {'from': 0, 'to': 0}
            }
        },
        {
            'module': 'NFT_MINTER',
            'params': {
                'nft_amount_interval': {'from': 2, 'to': 5},
                'nft_modules': ["ZKS_DOMAIN", "ERA_DOMAIN", "OMNI_SEA", "MERKLY_MINTER", "L2_TELEGRAPH_MINTER"],
                'sleep_interval': {'from': 0, 'to': 0}
            }
        }
    ]
}
